import { Scene, WebGLRenderer } from 'three';
import { ByondBaseElement } from './Core/ByondBaseElement';
import { BaseExperienceManager } from './Elements/ExperienceManager/BaseExperienceManager';
import { UserInteractionControlsImpl } from './Controls/UserInteractionControls/UserInteractionControlsImpl';
import { CameraControlsRegistryImpl } from './Core/Registrys/CameraControlsRegistry';
import { ElementsRegistryImpl } from './Core/Registrys/ElementsRegistry';
import { Subject } from 'rxjs';
import { AnimationManagerInstance as AnimationManager } from './Core/AnimationManager';
import { HistoryManager } from './Core/HistoryManager';
import { GoogleAnalytics } from './Utils';
export declare class AppManagerOptions {
    containerSelector: string;
    endpoint?: string;
    experienceManager: BaseExperienceManager;
    scene?: Scene;
    renderer?: WebGLRenderer;
    userControlers?: UserInteractionControlsImpl;
    zone?: string;
    debug?: boolean;
    boundsmode?: boolean;
    vr?: boolean;
    editor?: boolean;
}
export declare class AppManager extends ByondBaseElement {
    currentExperience: BaseExperienceManager;
    analytics: GoogleAnalytics;
    options: AppManagerOptions;
    container: HTMLElement;
    eventManager: Subject<import("@byondrnd/byond-web-lib/app/Core/EventManager/EventMessageImpl").IEventMessage>;
    editorEventManager: Subject<import("@byondrnd/byond-web-lib/app/Core/EventManager/EventMessageImpl").IEditorEventMessage>;
    renderEventManager: Subject<number>;
    historyManager: HistoryManager;
    animationManager: AnimationManager;
    debugMode: boolean;
    boundsMode: boolean;
    cameraControlsRegistry: CameraControlsRegistryImpl;
    elementsRegistry: ElementsRegistryImpl;
    constructor();
    init(options: AppManagerOptions): Promise<void>;
    animateTween(): void;
    Load(): Promise<void>;
    injectDependencies(): void;
    fetchCustomAttributeFromUrl(): void;
    setDebugMode(): void;
    destroy(): void;
}
