import { Vector3, Vector2, Group, Euler, PerspectiveCamera } from 'three';
import { CameraControlsImpl, ICameraControls } from './CameraControlsImpl';
import { AppManager } from '../../ByondViewer';
import { EasingType } from '../../Utils/Utils';
import { GyroOptions } from '../../Utils/GyroscopeManager';
export declare class DollyOptions {
    max_x: number;
    min_x: number;
    max_y: number;
    min_y: number;
    max_z: number;
    min_z: number;
    x_enabled: boolean;
    y_enabled: boolean;
    z_enabled: boolean;
    rotation: Euler;
    position: Vector3;
    screenSpacePanning: boolean;
    enable_damping: boolean;
    damping_factor: number;
    movementSpeedX: number;
    movementSpeedY: number;
    movementSpeedZ: number;
    movementSpeedMobileZ: number;
    gyro: GyroOptions;
}
export declare class DollyCameraControls extends CameraControlsImpl implements ICameraControls {
    camera: PerspectiveCamera;
    dollyOptions: DollyOptions;
    mousePosition: Vector2;
    moveSpeedY: number;
    moveSpeedX: number;
    zoomSpeed: number;
    zoomSpeedMobile: number;
    panOffset: Vector3;
    dolly: Group;
    constructor(appManager: AppManager, dollyOptions?: DollyOptions);
    init(cam?: PerspectiveCamera): Promise<void>;
    setCameraRotation(vector: Euler, time?: number): Promise<void>;
    setCameraAttr(cameraAttr: any): void;
    setCameraOptions(dollyOptions: DollyOptions): void;
    addListeners(): void;
    onSwipe(vector2: Vector2): void;
    onZoom(distance: number): void;
    panX(distance: number): void;
    panY(distance: number): void;
    panZ(distance: number): void;
    applyMotion(target: Vector3, time: number): void;
    checkPosition(): void;
    updateDamping(): void;
    changeCamPosition(targetPosition: Vector3, time?: number, onUpdate?: Array<Function>, easing?: EasingType): Promise<void>;
    changeCamRotation(lookAtTarget: Vector3, assumePosition?: Vector3, time?: number, onUpdate?: Array<Function>): Promise<void>;
    handleAccelerator(): void;
    _render(time?: any): void;
    destroy(): void;
}
