import { OrbitBasedCameraControls, OrbitControlsOptions } from './OrbitBasedCameraControls';
import { AppManager } from '../../ByondViewer';
import { Vector3, PerspectiveCamera } from 'three';
import { OrbitControls } from './Controls/OrbitControls';
export declare class OrbitCameraControls extends OrbitBasedCameraControls {
    orbitControls: OrbitControls;
    orbitOptions: OrbitControlsOptions;
    camera: PerspectiveCamera;
    rotateSpeed: number;
    max_y: number;
    min_y: number;
    target: {
        x: number;
        y: number;
        z: number;
    };
    constructor(appManager: AppManager, options?: OrbitControlsOptions);
    init(cam?: PerspectiveCamera): Promise<void>;
    onCameraMove(): void;
    ensureCameraLimits(): void;
    _render(time?: any): void;
    destroy(): void;
    setCameraHeight(floor: number, userHeight: number): Promise<void>;
    animateCamera(position: Vector3, lookAt?: Vector3, setTarget?: boolean, time?: number): Promise<void>;
    setCameraAttr(cameraAttr: any): void;
    setCameraOptions(options: OrbitControlsOptions): void;
}
