import { AppManager } from '../../ByondViewer';
import { Vector3, PerspectiveCamera } from 'three';
import { OrbitBasedCameraControls, OrbitControlsOptions } from './OrbitBasedCameraControls';
import { OrbitControls } from './Controls/OrbitControls';
export declare class TouchCameraControls extends OrbitBasedCameraControls {
    orbitControls: OrbitControls;
    orbitOptions: OrbitControlsOptions;
    camera: PerspectiveCamera;
    rotateSpeed: number;
    constructor(appManager: AppManager, options?: OrbitControlsOptions);
    init(cam?: PerspectiveCamera): Promise<void>;
    addListeners(): void;
    onMouseWheel(delta: any): void;
    _render(time?: any): void;
    destroy(): void;
    setCameraHeight(floor: number, userHeight: number): Promise<void>;
    animateCamera(position: Vector3, lookAt?: Vector3, setTarget?: boolean, time?: number): Promise<void>;
    setCameraPositionRotation(): Promise<void>;
    setCameraAttr(cameraAttr: any): Promise<void>;
    setCameraOptions(options: OrbitControlsOptions): void;
}
