import { VRCameraControls } from './VRCameraControls';
import { AppManager } from '../../ByondViewer';
import { Vector3, PerspectiveCamera, Object3D, Vector2 } from 'three';
import { EasingType } from '../../Utils/Utils';
import { OrbitControlsOptions } from './OrbitBasedCameraControls';
export declare class VROrbitCameraControls extends VRCameraControls {
    orbitOptions: OrbitControlsOptions;
    target: Vector3;
    dummyCamera: Object3D;
    dummyTarget: Object3D;
    zoomSpeedVR: number;
    moveSpeedVR: number;
    isVR: boolean;
    constructor(appManager: AppManager, options?: OrbitControlsOptions);
    init(cam?: PerspectiveCamera, display?: any, frameOfReferenceType?: any): Promise<void>;
    addListeners(): void;
    onSwipe(vector: Vector2): void;
    onZoom(distance: number): void;
    changeCamRotation(lookAtTarget: Vector3, assumePosition?: Vector3, time?: number): Promise<void>;
    changeCamPosition(targetPosition: Vector3, time?: number, onUpdate?: Array<Function>, easing?: EasingType): Promise<void>;
    setCameraAttr(cameraAttr: any): void;
    setCameraOptions(options: OrbitControlsOptions): void;
    destroy(): void;
}
