import { Vector2 } from 'three';
import { AppManager } from '../ByondViewer';
/** fix ts issue https://github.com/Microsoft/TypeScript/issues/9071 */
interface MouseWheelEvent extends MouseEvent {
    wheelDelta: number;
    wheelDeltaX: number;
    wheelDeltaY: number;
    initMouseWheelEvent(typeArg: string, canBubbleArg: boolean, cancelableArg: boolean, viewArg: Window, detailArg: number, screenXArg: number, screenYArg: number, clientXArg: number, clientYArg: number, buttonArg: number, relatedTargetArg: EventTarget, modifiersListArg: string, wheelDeltaArg: number): void;
}
declare var MouseWheelEvent: {
    prototype: MouseWheelEvent;
    new (): MouseWheelEvent;
};
export declare class MouseEventManager {
    appManager: AppManager;
    mousePosition: Vector2;
    initialRotate1: Vector2;
    initialRotate2: Vector2;
    rotateDistance: number;
    rotatePreviousAngle: number;
    pinchDistance: number;
    mouseIsDown: boolean;
    pintchStarted: boolean;
    rotateStarted: boolean;
    domElement: HTMLElement;
    swiptThreshold: number;
    longPressThreshold: number;
    touchTime: number;
    lastTouchUpTime: number;
    dbTapMaxInterval: number;
    constructor(appManager: AppManager);
    destroy(): void;
    onMouseDown(event: MouseEvent): void;
    onTouchStart(event: TouchEvent): void;
    onMouseUp(event: MouseEvent): void;
    onTouchEnd(event: TouchEvent): void;
    private IsLongPress;
    private IsSwipe;
    private IsDbTap;
    onMouseMove(event: MouseEvent): void;
    onTouchMove(event: TouchEvent): void;
    onDbClick(event: MouseEvent | TouchEvent): void;
    onMouseWheel(event: MouseWheelEvent): void;
    getMidpoint(x0: any, x1: any, y0: any, y1: any): {
        x: number;
        y: number;
    };
    getRightMostInput(x1: any, y1: any, x2: any, y2: any): {
        x: any;
        y: any;
    };
    getAngle(originX: any, originY: any, projectionX: any, projectionY: any): number;
    getAngularDistance(start: any, end: any): number;
}
export {};
