import { Color, Vector3, Object3D, RingGeometry, MeshBasicMaterial, Mesh, Camera } from 'three';
export declare class Gaze {
    enabled: boolean;
    parent: Object3D;
    geometryStart: RingGeometry;
    geometryEnd: RingGeometry;
    gazeMaterial: MeshBasicMaterial;
    gazeObj: Mesh;
    innerRadiusStart: number;
    outerRadiusStart: number;
    innerRadiusEnd: number;
    outerRadiusEnd: number;
    gazeTween: any;
    gazeColor: Color;
    hoverAnimTime: number;
    /** timer */
    geometryTimer: RingGeometry;
    materialTimer: MeshBasicMaterial;
    timerTween: any;
    timerObj: Mesh;
    innerRadiusTimer: number;
    outerRadiusTimer: number;
    phiSegmentsTimer: number;
    thetaSegmentsTimer: number;
    thetaStartTimer: number;
    selectionTime: number;
    constructor(parent: Object3D, gazeColor: Color, selectionTime: number);
    createTimer(): void;
    createGaze(): void;
    enable(): void;
    disable(): void;
    startAnimation(): void;
    stopAnimation(): void;
    animateTimer(time?: number, fillAmount?: number): void;
    updateVertices(geometry: RingGeometry, fillAmount: number): void;
    animateGaze(morphValue: number, time?: number): void;
    destroy(): void;
}
export declare class Cursor3D {
    camera: Camera;
    enabled: boolean;
    gaze: Gaze;
    colorStart: Color;
    colorEnd: Color;
    selectionTime: number;
    parentContainer: Object3D;
    deafultZPosition: number;
    deafultScale: Vector3;
    defaultHoverScale: number;
    constructor(camera: Camera, selectionTime: number);
    init(): void;
    updateCursorPosition(hit?: Vector3): void;
    startAnimation(): void;
    stopAnimation(): void;
    enable(): void;
    disable(): void;
    destroy(): void;
}
