import { Vector2, Object3D, Vector3, Raycaster, Camera } from 'three';
import { UserInteractionControlsImpl, HitInfo } from './UserInteractionControlsImpl';
export declare class MouseControls extends UserInteractionControlsImpl {
    mobileHover: boolean;
    detectCollisionFunc: any;
    onMouseDownFunc: any;
    detectClickFunc: any;
    detectTouchFunc: any;
    clickTimeout: number;
    dblClickThresholdTime: number;
    lastTouchUpTime: number;
    enable(): void;
    checkShouldDetectCollision(ctrl: MouseControls, event: MouseEvent | TouchEvent): void;
    checkShouldDetectTouch(ctrl: MouseControls, event: MouseEvent | TouchEvent): void;
    checkShouldDetectClick(ctrl: MouseControls, event: MouseEvent | TouchEvent): void;
    checkShouldOnMouseDown(ctrl: MouseControls, event: MouseEvent | TouchEvent): void;
    isDescendant(parent: HTMLElement, child: HTMLElement): boolean;
    disable(): void;
    enableMobileHover(): void;
    disableMobileHover(): void;
    triggerFocus(ctrl: UserInteractionControlsImpl, meshHit: Object3D, hit: Vector3): void;
    triggerUnfocus(ctrl: UserInteractionControlsImpl, meshHit: Object3D): void;
    detectCollision(ctrl: MouseControls, event: MouseEvent | TouchEvent): HitInfo;
    detectCollisionFromFOV(ctrl: UserInteractionControlsImpl, event: MouseEvent | TouchEvent): Vector3;
    loopFOV(): void;
    GetIntersectsFromController(raycaster: Raycaster, camera: Camera, domElm: HTMLCanvasElement, mousePos: Vector2, targetList: Array<Object3D>): import("three").Intersection[];
}
