import { AppManager } from '../../ByondViewer';
import { Object3D, Vector3, Mesh, Raycaster, Vector2, Color } from 'three';
import { Core } from '../..';
export declare class TransformControls {
    appManager: AppManager;
    raycaster: Raycaster;
    elements: Array<Core.ByondInteractiveElement.ByondInteractiveElement>;
    objects: Map<Core.ByondInteractiveElement.ByondInteractiveElement, Object3D>;
    initialTouchPosition: Vector3;
    initialScales: Map<Core.ByondInteractiveElement.ByondInteractiveElement, Vector3>;
    initialPositions: Map<Core.ByondInteractiveElement.ByondInteractiveElement, Vector3>;
    initialMaxVectors: Map<Core.ByondInteractiveElement.ByondInteractiveElement, Vector3>;
    initialMinVectors: Map<Core.ByondInteractiveElement.ByondInteractiveElement, Vector3>;
    scaleXEnabled: boolean;
    scaleYEnabled: boolean;
    posEnabled: boolean;
    scaleMouseMoveFunc: (event: MouseEvent | TouchEvent) => void;
    posMouseMoveFunc: (event: MouseEvent | TouchEvent) => void;
    updateMousePosFunc: (event: MouseEvent | TouchEvent) => void;
    onItemChangeStart: () => void;
    onItemChangeEnd: () => void;
    subscriptions: Array<any>;
    mousePos: Vector2;
    isMouseDown: boolean;
    handlersOffsetFactor: number;
    constructor(appManager: AppManager, onItemChangeStart: () => void, onItemChangeEnd: () => void);
    setHandlersOffsetFactor(factor: number): void;
    addListeners(): void;
    attach(elements: Array<Core.ByondInteractiveElement.ByondInteractiveElement>): void;
    getMaxVector(): Vector3;
    getMinVector(): Vector3;
    drawBoundingBoxes(): void;
    getScaleFromFov(growPrecentValue: number): Vector3;
    createControlSquare(x1: number, x2: number, y1: number, y2: number, z: number, color: Color | string | number): Mesh;
    onMouseDown(event: MouseEvent): void;
    isDragging(position: Vector3, updateProps?: boolean): boolean;
    onMouseUp(event: MouseEvent): void;
    removeMoveListeners(): void;
    removeListeners(): void;
    getElementZPositionFromTouch(event: MouseEvent | TouchEvent, element: Core.ByondInteractiveElement.ByondInteractiveElement): Vector3;
    updateMousePos(event: MouseEvent | TouchEvent): void;
    onPosition(event: MouseEvent | TouchEvent): void;
    onScale(event: MouseEvent | TouchEvent): void;
    deleteHandles(): void;
    detach(): void;
    update(): void;
    setMode(mode: string): void;
}
