import { Object3D, Vector3, Raycaster, Intersection } from 'three';
import { ByondInteractiveElement } from '../../Core/ByondInteractiveElement';
import { UserInteractionControls } from './UserInteractionControls';
import { AppManager } from '../../ByondViewer';
import { Subscription } from 'rxjs';
export interface HitInfo {
    intersection: Intersection;
    object: ByondInteractiveElement;
}
export declare abstract class UserInteractionControlsImpl implements UserInteractionControls {
    enabled: boolean;
    raycaster: Raycaster;
    timer: any;
    focusedElement?: Object3D;
    appManager: AppManager;
    longPressThreshold: number;
    longPressClickTime: number;
    targetList: Map<Object3D, ByondInteractiveElement>;
    subscribtions: Array<Subscription>;
    domElement: HTMLElement;
    constructor(appManager: AppManager, userInteractionControlsImpl?: UserInteractionControlsImpl);
    init(): void;
    reset(): void;
    enable(): void;
    disable(): void;
    addListeners(): void;
    AddObject(obj: Object3D, element: ByondInteractiveElement): void;
    RemoveObject(obj: Object3D): void;
    triggerLongTouch(ctrl: UserInteractionControlsImpl, meshHit: Object3D, hit: Vector3): void;
    triggerLongTouchEnded(ctrl: UserInteractionControlsImpl, meshHit: Object3D, hit: Vector3): void;
    triggerDoubleClick(ctrl: UserInteractionControlsImpl, meshHit: Object3D, hit: Vector3): void;
    triggerFocus(ctrl: UserInteractionControlsImpl, meshHit: Object3D, hit: Vector3): void;
    triggerUnfocus(ctrl: UserInteractionControlsImpl, meshHit: Object3D): void;
    triggerTouch(ctrl: UserInteractionControlsImpl, meshHit: Object3D, hit: Vector3): void;
    detectTouch(ctrl: UserInteractionControlsImpl, event: MouseEvent | TouchEvent): void;
    abstract detectCollision(ctrl: UserInteractionControlsImpl, event: MouseEvent | TouchEvent): HitInfo;
    abstract GetIntersectsFromController(...args: any[]): Intersection[];
    getHitInfoFromIntersection(ctrl: UserInteractionControlsImpl, intersection: Intersection): HitInfo;
    getElementFromObject(ctrl: UserInteractionControlsImpl, obj?: Object3D): ByondInteractiveElement;
    onMouseDown(ctrl: UserInteractionControlsImpl): void;
    removeListeners(): void;
    destroy(): void;
}
