import { Camera, Matrix4 } from 'three';
import { AppManager } from '../ByondViewer';
export declare class ARMarkerManager {
    onRenderFcts: any[];
    arToolkitSource: THREEx.ArToolkitSource;
    arToolkitContext: THREEx.ArToolkitContext;
    markerIsOn: boolean;
    domElement: HTMLCanvasElement;
    camera: Camera;
    enabled: boolean;
    markerControls: THREEx.ArMarkerControls;
    stopTracking: boolean;
    appManager: AppManager;
    constructor(appManager: AppManager, domElement: HTMLCanvasElement, camera: Camera);
    setMarker(markerPath: any): Promise<void>;
    StopTracking(): void;
    StartTracking(): void;
    onMarker(): void;
    offMarker(): void;
    setEnabled(enable: boolean): void;
    private enable;
    private disable;
    render(): void;
    onResize(): void;
    Destroy(): void;
}
declare namespace THREEx {
    class ARClickability {
        constructor(sourceElement: any);
        computeIntersects: (DOMEvent: any, objects: any) => any;
        onResize: () => any;
        update: () => any;
    }
    class ArBaseControls {
        constructor(object3d: any);
        addEventListener: (type: any, listener: any) => {};
        hasEventListener: (type: any, listener: any) => {};
        removeEventListener: (type: any, listener: any) => {};
        dispatchEvent: (event: any) => {};
        name: () => {};
        update: () => {};
    }
    class ArMarkerCloak {
        constructor(videoTexture: any);
        fragmentShader: any;
        markerSpaceShaderFunction: any;
        vertexShader: any;
    }
    class ArMarkerControls {
        constructor(context: any, object3d: any, parameters: any);
    }
    class ArMarkerHelper {
        constructor(markerControls: any);
    }
    class ArMultiMakersLearning {
        constructor(arToolkitContext: any, subMarkersControls: any);
    }
    class ArMultiMarkerControls {
        constructor(arToolkitContext: any, object3d: any, parameters: any);
    }
    const ArMultiMarkerUtils: any;
    class ArSmoothedControls {
        constructor(object3d: any, parameters: any);
    }
    interface ArToolkitContextParameters {
        cameraParametersUrl?: string;
        detectionMode: 'color' | 'color_and_matrix' | 'mono' | 'mono_and_matrix';
        patternRatio?: number;
        canvasWidth?: number;
        canvasHeight?: number;
        debug?: boolean;
    }
    class ArToolkitContext {
        static baseURL: string;
        arController: any;
        constructor(parameters: ArToolkitContextParameters);
        init: (parameters: any) => {};
        update: (parameters: any) => {};
        getProjectionMatrix: () => Matrix4;
    }
    class ArToolkitProfile {
        constructor();
    }
    interface ArToolkitSourceParameters {
        sourceType: 'webcam' | 'image' | 'video';
        sourceUrl?: string;
        sourceWidth?: number;
        sourceHeight?: number;
        displayWidth?: number;
        displayHeight?: number;
    }
    class ArToolkitSource {
        constructor(parameters: ArToolkitSourceParameters);
        init: (parameters: any) => {};
        onResize: () => {};
        copySizeTo: (parameters: any) => {};
        ready: boolean;
        domElement: any;
    }
    class ArVideoInWebgl {
        constructor(videoTexture: any);
    }
}
export {};
