import { Object3D } from 'three';
import { Metadata } from './Metadata';
import { ByondCommonActionDescriptor, InteractableImpl } from '../Controls/UserInteractionControls/InteractableActions';
import { Subscription } from 'rxjs';
import { IEditorEventMessage } from './EventManager/EventMessageImpl';
import * as EventTypes from './EventManager/EventTypes';
import { AppManager } from '../ByondViewer';
import { IByondBaseElement } from './ByondBaseElement.interface';
import { EffectImpl } from '../Effects/EffectImpl';
export declare class ByondBaseElement implements IByondBaseElement {
    protected id: string;
    obj: Object3D;
    appManager: AppManager;
    parent: ByondBaseElement;
    interactable: InteractableImpl;
    destroyed: boolean;
    protected visible: boolean;
    protected enabled: boolean;
    protected state: EventTypes.IElementLifeCycleEvent;
    protected metadata: Metadata.BaseElementMetadata;
    protected componentList: any[];
    protected effects: EffectImpl[];
    protected subscriptions: Subscription[];
    protected editorUuid: string;
    protected childElements: Array<IByondBaseElement>;
    constructor(metadata: Metadata.BaseElementMetadata, parent: ByondBaseElement, element_id?: string);
    init(options?: any): Promise<any>;
    HandleEditorEventStarted(event: IEditorEventMessage): void;
    HandleEditorEventEnded(event: IEditorEventMessage): void;
    createChildElement(elementsMetadata: Metadata.BaseElementMetadata): Promise<void>;
    ofterZoneLoaded(): void;
    setCustomParent(): void;
    activate(descriptor: ByondCommonActionDescriptor): void;
    activateChildElementHandler(descriptor: ByondCommonActionDescriptor): void;
    onChildDeleted(child: IByondBaseElement): void;
    onChildDestroyed(child: IByondBaseElement): void;
    destroy(): void;
    getMetadata(): Metadata.BaseElementMetadata;
    setState(state: EventTypes.IElementLifeCycleEvent): void;
    get isEnabled(): boolean;
    setEnabled(enable: boolean): void;
    setVisible(visible: boolean, time?: number): Promise<any>;
    get isVisible(): boolean;
    Id(): string;
    handleDependencies(): Promise<void>;
    injectAndResolveModule(src: string): Promise<void>;
    getCustomAttribute(key: string, fromChild?: boolean): any;
    addCustomAttribute(key: string, value: any): void;
    DownloadCustomAttributes(url: string): Promise<Metadata.CustomAttributesMetadata[]>;
    attachElement(component: any): any;
    detachElement(component: any): void;
    addEditorItems(): void;
    GetElementName(): string;
}
