import { Metadata } from './Metadata';
import { ByondBaseElement } from './ByondBaseElement';
import { AppManager } from '../ByondViewer';
/**
 * This based class is for creating an instance of ByondElements base on Metadata
 */
export interface ByondBaseElementFactory {
    predicate(metadata: Metadata.BaseElementMetadata): boolean;
    init(): any;
    create(metadata: Metadata.BaseElementMetadata, parent: ByondBaseElement, element_ld?: string): ByondBaseElement | Promise<ByondBaseElement>;
    register(): any;
    unregister(): any;
}
export declare abstract class ByondBaseElementFactoryImpl implements ByondBaseElementFactory {
    appManager: AppManager;
    constructor(appManager: AppManager);
    abstract predicate(metadata: Metadata.BaseElementMetadata): boolean;
    abstract init(): any;
    abstract create(metadata: Metadata.BaseElementMetadata, parent: ByondBaseElement, element_ld?: string): Promise<ByondBaseElement>;
    abstract register(): any;
    abstract unregister(): any;
}
