export declare namespace CustomAttributes {
    const PlcaHolderAttribut: RegExp;
    /** --------------  keys  -------------------------------------------------- */
    /** all elements */
    const Dependencies = "$$dependencies";
    const ElementEvents = "$$element_events";
    /** Experience */
    /** google analytics tracker id */
    const GAID = "$$ga_id";
    const GTAG = "$$gtag";
    const PREFETCH = "$$prefetch";
    const EXPERIENCE_LOADER = "$$experience_loader";
    const EXPERIENCE_LOADER_OPACITY = "$$experience_loader_opacity";
    const ZONE_LOADER = "$$zone_loader";
    const ZONE_LOADER_OPACITY = "$$zone_loader_opacity";
    /** Experience, Zone */
    const UserHeight = "$$user_height";
    const FloorLevel = "$$floor_level";
    /** ARZone */
    const PreviewTransform = "$$preview_transform";
    const ApiKey = "$$ar_api_key";
    /** Zone */
    const GammaFactor = "$$gamma_factor";
    const physicallyCorrectLights = "$$physically_correct_lights";
    const CameraZoom = "$$camera_zoom";
    const ZoneType = "$$zone_type";
    /** Background */
    const Background = "$$background";
    const BackgroundVideoLoop = "$$background_video_loop";
    const BackgroundVideoAutoplay = "$$background_video_autoplay";
    /** Lights */
    const ShadowBiasCustomAttribute = "$$shadow.bias";
    const ShadowMapCustomAttribute = "$$shadow_map";
    /** relevant only for ByondInteractiveElement */
    const RenderOrder = "$$render_order";
    const Teleport = "$$teleport";
    const EnvironmentMap = "$$environment_map";
    const Parent = "$$parent";
    const Wireframe = "$$wireframe";
    const Effects = "$$effects";
    const LookAt = "$$look_at";
    const Bounds = "$$bounds";
    const OptimizationWidth = "$$optimization_width";
    /** relevant for teleport */
    const TeleportOffset = "$$teleport_offset";
    /** relevant for screenImage */
    const Bullet = "$$bullet";
    const ProgressiveLoading = "$$progressive_loading";
    const SVGSize = "$$svg_size";
    /** relevant for screenVideo */
    const ChromakeyOption = "$$chromakey_option";
    /** relevant only for Obj Models */
    const LOD = "$$lod";
    const CenterPivot = "$$center_pivot";
    /** relevant only for Screens */
    const PreviewImage = "$$preview_image";
    /** --------------  Values  -------------------------------------------------- */
    const Values: {
        ZoneType: {
            AR: string;
        };
        EnvMap: {
            Auto: string;
            Realtime: string;
            FromSource: string;
        };
        Effects: {
            ColorAdjustmentEffect: string;
        };
        CustomParent: {
            Camera: string;
        };
        LookAt: {
            Camera: string;
        };
    };
}
