import { Subject } from 'rxjs';
import { IEventType } from './EventTypes';
import { EditorEventType } from './EditorEventType';
import { Vector3, Euler } from 'three';
import { Metadata } from '../Metadata';
import { ByondInteractiveElement } from '../ByondInteractiveElement';
export interface IEventMessage {
    origin: any;
    eventType: IEventType;
    message?: any;
}
export declare class EventMessage {
    origin: any;
    eventType: IEventType;
    message?: any;
    constructor(origin: any, eventType: IEventType, message?: any);
}
export declare class EventManager {
    readonly subject: Subject<IEventMessage>;
}
declare type actionType = 'undo' | 'redo' | 'action';
export interface IEditorEventMessage {
    originId: string;
    type: EditorEventType.BasePropEvent;
    value?: {
        position?: Vector3;
        scale?: Vector3;
        rotation?: Euler;
        metadata?: Metadata.BaseElementMetadata;
        element?: ByondInteractiveElement;
    };
    editStart?: boolean;
    actionType?: actionType;
}
export declare class EditorEventManager {
    readonly subject: Subject<IEditorEventMessage>;
}
export interface IHistoryEventMessage {
    originId: string;
    type: EditorEventType.BasePropEvent;
    oldValue?: {
        position?: Vector3;
        scale?: Vector3;
        rotation?: Euler;
        metadata?: Metadata.BaseElementMetadata;
    };
    historyMode: actionType;
}
export declare class HistoryEventManager {
    readonly subject: Subject<IHistoryEventMessage>;
}
export {};
