export interface IEventType {
    readonly name: string;
}
/** Render events */
export declare class ShouldRenderEvent implements IEventType {
    readonly name: string;
    readonly time: number;
}
/** lifecycle events */
export declare abstract class IElementLifeCycleEvent implements IEventType {
    readonly name: string;
}
export declare class CameraMoveEvent implements IElementLifeCycleEvent {
    readonly name: string;
}
export declare class CameraZoomEvent implements IElementLifeCycleEvent {
    readonly name: string;
}
export declare class CameraChangedEvent implements IElementLifeCycleEvent {
    readonly name: string;
}
export declare class UninitializedEvent implements IElementLifeCycleEvent {
    readonly name: string;
}
export declare class LoadingEvent implements IElementLifeCycleEvent {
    readonly name: string;
}
export declare class LoadedEvent implements IElementLifeCycleEvent {
    readonly name: string;
}
export declare class DestroyedEvent implements IElementLifeCycleEvent {
    readonly name: string;
}
export declare class ErrEvent implements IElementLifeCycleEvent {
    readonly name: string;
}
/** interaction events */
export declare class TouchEvent implements IEventType {
    readonly name: string;
}
/** interaction events */
export declare class LongTouchEvent implements IEventType {
    readonly name: string;
}
export declare class LongTouchEndedEvent implements IEventType {
    readonly name: string;
}
/** interaction events */
export declare class GyroMotionEvent implements IEventType {
    readonly name: string;
}
export declare class FocusEvent implements IEventType {
    readonly name: string;
}
export declare class UnfocusEvent implements IEventType {
    readonly name: string;
}
/** others */
export declare class PropertieChangedEvent implements IEventType {
    readonly name: string;
}
/** Effect custom event */
export declare class EffectStartedEvent implements IEventType {
    readonly name: string;
}
export declare class EffectEndedEvent implements IEventType {
    readonly name: string;
}
/** transition registry custom event */
export declare class TransitionStartedEvent implements IEventType {
    readonly name: string;
}
export declare class TransitionEndedEvent implements IEventType {
    readonly name: string;
}
/** experience manager custom event */
export declare class NavigateEvent implements IEventType {
    readonly name: string;
}
export declare class ZoneChangeStartedEvent implements IEventType {
    readonly name: string;
}
export declare class ZoneChangeEndedEvent implements IEventType {
    readonly name: string;
}
export declare class ChatMessageSentEvent implements IEventType {
    readonly name: string;
}
export declare class KeyboardClickEvent implements IEventType {
    readonly name: string;
}
export declare class ARModeStarted implements IEventType {
    readonly name: string;
}
export declare class ARModeEnded implements IEventType {
    readonly name: string;
}
export declare class ARMarkerDetected implements IEventType {
    readonly name: string;
}
export declare class ARMarkerUndetected implements IEventType {
    readonly name: string;
}
export declare class MouseSwipeEvent implements IEventType {
    readonly name: string;
}
export declare class GamepadSwipeEvent implements IEventType {
    readonly name: string;
}
export declare class GamepadPressSwipeEvent implements IEventType {
    readonly name: string;
}
export declare class MouseDownEvent implements IEventType {
    readonly name: string;
}
export declare class GamepadDownEvent implements IEventType {
    readonly name: string;
}
export declare class GamepadUpEvent implements IEventType {
    readonly name: string;
}
export declare class MouseUpEvent implements IEventType {
    readonly name: string;
}
export declare class MouseDoubleClickEvent implements IEventType {
    readonly name: string;
}
export declare class MouseMoveEvent implements IEventType {
    readonly name: string;
}
export declare class PinchEvent implements IEventType {
    readonly name: string;
}
export declare class RotateEvent implements IEventType {
    readonly name: string;
}
export declare class MouseWheelEvent implements IEventType {
    readonly name: string;
}
export declare class ARObjectPlacedEvent implements IElementLifeCycleEvent {
    readonly name: string;
}
export declare class AnalyticsSendActionEvent implements IElementLifeCycleEvent {
    readonly name: string;
}
