import { Box3 } from 'three';
import { Subscription } from 'rxjs';
import { ByondInteractiveElement } from '../Core/ByondInteractiveElement';
export interface LodManagerOptions {
    lods: Array<LodOption>;
}
export interface LodOption {
    distance?: number;
    url: string;
}
export interface LodSupported extends ByondInteractiveElement {
    lodManager: LodManager;
    changeLod(lodOption: LodOption): any;
}
export declare class LodManager {
    lodManagerOptions: LodManagerOptions;
    lod: number;
    currentLodOption: LodOption;
    boundingBox: Box3;
    element: LodSupported;
    subscription: Subscription;
    constructor(lodManagerOptions: LodManagerOptions, element: LodSupported);
    calcLod(): void;
    calcDistance(): void;
    changeLod(lod: number): void;
    destroy(): void;
}
