import { Vector3, Euler } from 'three';
export declare namespace Metadata {
    class CustomAttributesMetadata {
        key: string;
        value: any;
    }
    abstract class BaseElementMetadata {
        custom_attributes?: CustomAttributesMetadata[];
        abstract get ElementName(): string;
        byond_id?: any;
        title?: string;
        getCustomAttribute(key: string): any;
    }
    abstract class Element3DMetadata extends BaseElementMetadata {
        readonly metadataName = "Element3DMetadata";
        position: Vector3;
        rotation?: Euler;
        scale: Vector3;
        is_cast_shadow: boolean;
        is_receive_shadow: boolean;
    }
    class OnHover {
        value: string | Vector3;
        type: string;
    }
    class OnClick {
        type?: string;
        value?: string;
    }
    class ZoneMetadata extends BaseElementMetadata {
        title?: string;
        bg?: string;
        bg_medium?: string;
        bg_type?: string;
        is_stereoscopic: boolean;
        zone_type?: string;
        projection_type: string;
        elements?: BaseElementMetadata[];
        get ElementName(): string;
    }
    class BaseExperienceMetadata extends Metadata.BaseElementMetadata {
        configuration?: Metadata.Configuration;
        title: string;
        hash: string;
        get ElementName(): string;
    }
    class ExperienceMetadata extends BaseExperienceMetadata {
        locations: Metadata.ZoneMetadata[];
    }
    class Marker {
        pinned?: boolean;
        marker: MarkerInfo;
    }
    class MarkerInfo {
        byond_id: string;
        id: string;
        asset: string;
        zone: string;
    }
    class Asset {
        byond_id: string;
        endpoint: string;
        type: string;
    }
    class Dependencies {
        css: string[];
        scripts: string[];
        assets: Asset[];
    }
    class ActivationConfig {
        markers?: Marker[];
    }
    class Configuration {
        dependencies?: Dependencies;
        activation_config?: ActivationConfig;
    }
}
