import { ScreenNode, FloatNode, ColorAdjustmentNode, NodeFrame } from 'three/examples/jsm/nodes/Nodes';
import { NodePass } from 'three/examples/jsm/nodes/postprocessing/NodePass';
import { AppManager } from '../../ByondViewer';
import { EffectImpl } from '../EffectImpl';
import { Clock } from 'three';
export interface ColorAdjustmentEffectOptions {
    hue: number;
    sataturation: number;
    vibrance: number;
    brightness: number;
    contrast: number;
}
export declare class ColorAdjustmentEffect extends EffectImpl {
    nodePass: NodePass;
    screen: ScreenNode;
    hue: FloatNode;
    sataturation: FloatNode;
    vibrance: FloatNode;
    brightness: FloatNode;
    contrast: FloatNode;
    hueNode: ColorAdjustmentNode;
    satNode: ColorAdjustmentNode;
    vibranceNode: ColorAdjustmentNode;
    brightnessNode: ColorAdjustmentNode;
    contrastNode: ColorAdjustmentNode;
    clock: Clock;
    frame: NodeFrame;
    colorAdjustmentEffectOptions: ColorAdjustmentEffectOptions;
    constructor(appManager: AppManager, colorAdjustmentEffectOptions?: ColorAdjustmentEffectOptions);
    init(): void;
    setColorAdjustmentEffectOptions(): void;
    start(): void;
    stop(): void;
    render(): void;
    addEditorItems(menuName: string, editorUuid: string): void;
}
