import { Texture, Object3D } from 'three';
import { RenderPass } from 'three/examples/jsm/postprocessing/RenderPass';
import { ShaderPass } from 'three/examples/jsm/postprocessing/ShaderPass';
import { OutlinePass as THREEOutlinePass } from 'three/examples/jsm/postprocessing/OutlinePass';
import { EffectImpl } from './EffectImpl';
import { AppManager } from '../ByondViewer';
import { ByondBaseElement } from '../Core/ByondBaseElement';
export declare class OutlinePass extends THREEOutlinePass {
    patternTexture: Texture;
}
export declare class OutlineEffectOptions {
    edgeStrength: number;
    edgeGlow: number;
    edgeThickness: number;
    pulsePeriod: number;
    visibleEdgeColor: string;
    hiddenEdgeColor: string;
    patternTexture?: Texture;
}
export declare class OutlineEffect extends EffectImpl {
    effectFXAA: ShaderPass;
    renderPass: RenderPass;
    outlinePass: OutlinePass;
    objectList: Object3D[];
    options: OutlineEffectOptions;
    constructor(appManager: AppManager, options?: OutlineEffectOptions);
    attachObject(elm: ByondBaseElement): void;
    dettachObject(elm: ByondBaseElement): void;
    init(): void;
    start(): void;
    stop(): void;
    onResize(): void;
    destroy(): void;
}
