import { Texture } from 'three';
import { MultiResCube } from './MultiResCube';
import { ByondBaseElement } from '../../../../Core/ByondBaseElement';
import { CubemapBackground } from '../CubemapBackground';
import { BackgroundMetadata } from '../../../../Factories/BackgroundImageFactory';
interface Faces {
    px: string;
    nx: string;
    py: string;
    ny: string;
    pz: string;
    nz: string;
}
declare type CubeType = 'face' | 'vertical' | 'cross';
export declare class CubemapBackgroundImage extends CubemapBackground {
    obj: MultiResCube;
    previceCubeType: CubeType;
    cubeType: CubeType;
    constructor(metadata: BackgroundMetadata, parent: ByondBaseElement);
    init(): Promise<any>;
    setAlpha(alpha: number, time?: number): Promise<any>;
    loadCubemap(): Promise<void>;
    loadPreview(): Promise<void>;
    getFaceTexturesFromRelativePath(path: string, format?: string): any[];
    getPreviewRelativePath(): string;
    getRelativePath(): string;
    getFaceTextures(urls: Faces): (() => Promise<Texture>)[];
    applyTextureToFace(textPromise: Promise<Texture>, face: number): Promise<void>;
    getMetadata(): BackgroundMetadata;
    destroy(): void;
}
export {};
