import { Texture, PlaneGeometry, MeshBasicMaterial, Mesh } from 'three';
import { ScreenMetadata } from '../../Factories/ScreenFactory/Metadata';
import { Metadata } from '../../Core/Metadata';
import { ByondInteractiveElement } from '../../Core/ByondInteractiveElement';
import { ByondBaseElement } from '../../Core/ByondBaseElement';
export declare class CanvasInteractiveElement extends ByondInteractiveElement {
    width: number;
    height: number;
    canvas: HTMLCanvasElement;
    context: CanvasRenderingContext2D;
    isTransparent: boolean;
    obj: Mesh;
    protected geometry: PlaneGeometry;
    protected material: MeshBasicMaterial;
    protected metadata: ScreenMetadata;
    constructor(metadata: Metadata.Element3DMetadata, parent: ByondBaseElement, element_id?: string, isTransparent?: boolean, width?: any, height?: any);
    init(): Promise<void>;
    getMetadata(): Metadata.Element3DMetadata;
    updateTexture(): Promise<void>;
    getTextureFromCanvas(): Texture;
    clear(): void;
    roundedRect(ctx: any, x: any, y: any, width: any, height: any, radius: number, fill: any, strokeStyle?: any, lineWidth?: any): any;
    destroy(): void;
}
