import { Mesh, MeshBasicMaterial } from 'three';
import { CSS3DObject } from 'three/examples/jsm/renderers/CSS3DRenderer';
import { ByondInteractiveElement } from '../../Core/ByondInteractiveElement';
import { CssElementMetadata } from '../../Factories/CSSElementFactory/Metadata';
import { ByondBaseElement } from '../../Core/ByondBaseElement';
/** example:
 *
 *  const cssMeta = new CssElementMetadata();
 *  cssMeta.position = new Vector3(5, 0, 5);
 *  cssMeta.html = '<img src=\'https://s3.amazonaws.com/webapps.byondvr.com/assets/images/hotspots/balloon.png\'/>';
 *  cssMeta.width = 5;
 *  cssMeta.height = 5;
 *  const cssElemets = new CssElement(cssMeta, this);
 *  await cssElemets.init();
 *  await cssElemets.setVisible(true, 1);
 *  cssElemets.setEnabled(true);
 *
 */
export declare class CssElement extends ByondInteractiveElement {
    protected material: MeshBasicMaterial;
    html: HTMLDivElement;
    css: HTMLStyleElement;
    cssObject: CSS3DObject;
    obj: Mesh;
    constructor(metadata: CssElementMetadata, parent: ByondBaseElement, element_id?: string);
    init(): Promise<void>;
    setVisible(visible: boolean, time?: number): Promise<any>;
    setAlpha(alpha: number, time?: number): Promise<void>;
    getMetadata(): CssElementMetadata;
    destroy(): void;
}
