import { Core } from '../../';
import { ByondBaseElement } from '../../Core/ByondBaseElement';
import { ZoneManagerImpl } from '../ZoneManager/ZoneManagerImpl';
import { TransitionManager } from '../../Core/TransitionManager';
import { WebGLRenderer, Scene, Light } from 'three';
import { MouseEventManager } from '../../Controls/MouseEventManager';
import { VRControllerEventManager } from '../../Controls/VRControllerEventManager';
import { TransitionsRegistry } from '../../Core/Registrys/TransitionsRegistry';
import { CameraControlsRegistryImpl } from '../../Core/Registrys/CameraControlsRegistry';
import { UserInteractionControlsRegistry } from '../../Core/Registrys/UserInteractionControlsRegistry';
import { CSS3DRenderer } from 'three/examples/jsm/renderers/CSS3DRenderer';
import { ElementControlesManager } from '../../Controls/UserInteractionControls/ElementControlesManager';
import { PrefetchManager } from '../../Core/PrefetchManager';
export declare abstract class BaseExperienceManager extends ByondBaseElement {
    currentZone?: ZoneManagerImpl | any;
    backgroundManager: TransitionManager;
    renderer: WebGLRenderer;
    cssRenderer: CSS3DRenderer;
    ambientLight: Light;
    transitionsRegistry: TransitionsRegistry;
    prefetchManager: PrefetchManager;
    mouseEventManager: MouseEventManager;
    vrControllerEventManager: VRControllerEventManager;
    userInteractionControlsRegistry: UserInteractionControlsRegistry;
    cameraControlsRegistry: CameraControlsRegistryImpl;
    elementControlesManager: ElementControlesManager;
    editor: any;
    scene: Scene;
    constructor(stringMetadata: string, parent: ByondBaseElement, element_id?: string);
    init(): Promise<void>;
    abstract exportMetadata(saveFileName?: String): any;
    abstract navigate(toZoneNumber: string): any;
    abstract deserialize(stringMeta: string): Core.Metadata.BaseExperienceMetadata;
    afterExperienceInit(): void;
    animateTween(): void;
    handleCurrentZoneCamera(preventVR?: boolean): Promise<void>;
    onResize(): void;
    getMetadata(): Core.Metadata.BaseExperienceMetadata;
    destroy(): void;
}
