import { Group } from 'three';
import { BaseGalleryElementMetadata } from '../../Factories/GenericGalleryFactory/GenericMetadata';
import { ByondInteractiveElement } from '../../Core/ByondInteractiveElement';
import { ByondBaseElement } from '../../Core/ByondBaseElement';
import { Metadata } from '../../Core/Metadata';
export declare abstract class GalleryImpl<T extends BaseGalleryElementMetadata<V>, V extends Metadata.BaseElementMetadata> extends ByondInteractiveElement {
    objects: Array<ByondBaseElement[]>;
    metadata: T;
    obj: Group;
    orderedMetadata: Array<V[]>;
    constructor(metadata: T, parent: ByondBaseElement, element_id?: string, nRow?: number, nCol?: number);
    constructGalleryObjects(objectGroupMetadata: V[]): Promise<any[]>;
    abstract constructObject(metadata: V, parent: ByondBaseElement): any;
    init(): Promise<void>;
    setEnabled(enable: boolean): void;
    setVisible(visible: boolean, time?: number): Promise<any>;
    setObjectGroupVisible(visible: boolean, objectGroup: ByondBaseElement[], time?: number): Promise<any>;
    setObjectGroupEnabled(enable: boolean, objectGroup: ByondBaseElement[]): void;
    objectsSortOrder(objectsMetadata: V[]): V[];
    destroy(): void;
}
