import { Vector3, Euler } from 'three';
import { GalleryNavigationButtons } from './GalleryNavigationButtons';
import { ScreenImage } from '../../Screens/ScreenImage';
import { Metadata } from '../../../Core/Metadata';
import { BaseGalleryElementMetadata } from '../../../Factories/GenericGalleryFactory/GenericMetadata';
export declare class GalleryNavigationButton<T extends BaseGalleryElementMetadata<V>, V extends Metadata.BaseElementMetadata> extends ScreenImage {
    pageIndex: number;
    active: boolean;
    activeAlpha: number;
    unactiveAlpha: number;
    galleryBtnManager: GalleryNavigationButtons<T, V>;
    constructor(pageIndex: number, galleryBtnManager: GalleryNavigationButtons<T, V>, position: Vector3, rotation?: Euler, scale?: Vector3, element_id?: string);
    onHover(): void;
    onUnHover(): void;
    setActive(active: boolean): void;
    activateElement(): Promise<void>;
    deactivateElement(): Promise<void>;
    init(): Promise<void>;
}
