import { Group } from 'three';
import { Metadata } from '../../../Core/Metadata';
import { ByondInteractiveElement } from '../../../Core/ByondInteractiveElement';
import { GridBasedGallery } from '../GridBasedGallery';
import { GalleryNavigationButton } from './GalleryNavigationButton';
import { Row } from '../../Grid/Row';
import { Cell } from '../../Grid/Cell';
import { BaseGalleryElementMetadata } from '../../../Factories/GenericGalleryFactory/GenericMetadata';
export declare class GalleryNavigationButtons<T extends BaseGalleryElementMetadata<V>, V extends Metadata.BaseElementMetadata> extends ByondInteractiveElement {
    row: Row;
    nOfPaged: number;
    obj: Group;
    buttons: Array<GalleryNavigationButton<T, V>>;
    gallery: GridBasedGallery<T, V>;
    constructor(gallery: GridBasedGallery<T, V>, nOfPaged: number, element_id?: string);
    animateToPage(button: GalleryNavigationButton<T, V>): void;
    init(): Promise<void>;
    setVisible(visible: boolean, time?: number): Promise<any>;
    setEnabled(enable: boolean): void;
    initAndAttachBtnToCell(btn: GalleryNavigationButton<T, V>, cell: Cell): Promise<void>;
}
