import { Vector3, Group, Vector2 } from 'three';
import { BaseGalleryElementMetadata } from '../../Factories/GenericGalleryFactory/GenericMetadata';
import { ByondBaseElement } from '../../Core/ByondBaseElement';
import { GridBasedGallery } from './GridBasedGallery';
import { GalleryImpl } from './GalleryImpl';
import { Metadata } from '../../Core/Metadata';
export declare class LayeredGallery<T extends BaseGalleryElementMetadata<V>, V extends Metadata.BaseElementMetadata> extends GalleryImpl<T, V> {
    layersDistance: number;
    galleries: GridBasedGallery<T, V>[];
    metadata: T;
    obj: Group;
    constructor(metadata: T, parent: ByondBaseElement, element_id?: string);
    init(): Promise<void>;
    constructObject(metadata: V, parent: ByondBaseElement): Promise<ByondBaseElement>;
    orderMetadata(): V[][];
    setLayersDistance(dist: number): void;
    getLayersDistance(): number;
    addScreensLayer(screensMetadata: V[], layerRows?: number, layerCols?: number, layerAlpha?: number, layerPadding?: number, layerMargin?: Vector2, layerCellSize?: Vector3, layerIndex?: number): void;
    setEnabled(enable: boolean): void;
    setLayerEnabled(gallery: GridBasedGallery<T, V>, enable: boolean): void;
    setLayerVisible(gallery: GridBasedGallery<T, V>, visible: boolean): Promise<void>;
    setLayerAlpha(gallery: GridBasedGallery<T, V>, alpha: number, time?: number): Promise<void>;
    setVisible(visible: boolean, time?: number): Promise<any>;
    setAlpha(alpha: number, time?: number): Promise<any>;
    destroy(): void;
}
