import { Vector3, Group, Vector2 } from 'three';
import { ByondInteractiveElement } from '../../Core/ByondInteractiveElement';
import { Grid } from '../Grid/Grid';
import { ByondBaseElement } from '../../Core/ByondBaseElement';
import { Cell } from '../Grid/Cell';
import { GalleryNavigationButtons } from './GalleryNavigationButtons/GalleryNavigationButtons';
import { GalleryImpl } from './GalleryImpl';
import { Metadata } from './../../Core/Metadata';
import { BaseGalleryElementMetadata } from '../../Factories/GenericGalleryFactory/GenericMetadata';
export declare class GridBasedGallery<T extends BaseGalleryElementMetadata<V>, V extends Metadata.BaseElementMetadata> extends GalleryImpl<T, V> {
    grid: Grid;
    alpha: number;
    padding: number;
    margin: Vector2;
    cellSize: Vector3;
    galleryNavigationButtons: GalleryNavigationButtons<T, V>;
    currentPage: number;
    metadata: T;
    nRow: number;
    nCol: number;
    nOfPages: number;
    nElementsInPage: number;
    obj: Group;
    constructor(metadata: T, parent: ByondBaseElement, element_id?: string, nRow?: number, nCol?: number, alpha?: number, padding?: number, margin?: Vector2, cellSize?: Vector3);
    constructElementsPage(pageN: number): Promise<void>;
    init(): Promise<void>;
    constructObject(metadata: V, parent: ByondBaseElement): Promise<ByondBaseElement>;
    setEnabled(enable: boolean): void;
    setVisible(visible: boolean, time?: number): Promise<any>;
    setAlpha(alpha: number, time?: number): Promise<any>;
    initPage(pageN: number): Promise<void>;
    initAndAttachElementsToCell(element: ByondInteractiveElement, cell: Cell): Promise<void>;
    get CurrentPageElements(): Array<ByondBaseElement>;
    animateToPage(nPage: number): Promise<void>;
    animatePage(page: number, targetPosition: Vector3, sourcePositon?: Vector3, targetAlpah?: number, time?: number): Promise<void>;
}
