import { Mesh, Object3D, Vector3 } from 'three';
import { GridBaseElement } from './GridBaseElement';
/**
 * example:
 * var cell = new Cell(this.appManager.scene, null, new Vector3(0, -5, 10), new Vector3(1, 1, 1));
 *  await cell.init();
 *  cell.setContainedChild((<ByondInteractiveElement>this.elementsList[0]).obj);
 *  cell.wireframe = true;
 *  cell.enable();
 */
export declare class Cell extends GridBaseElement {
    accuracy: number;
    containedObj: Mesh;
    padding: number;
    constructor(parent: GridBaseElement | Object3D, initialPosition: Vector3, cellSize: Vector3, padding?: number);
    init(): void;
    enable(): Promise<void>;
    disable(): void;
    get hasChild(): boolean;
    setContainedChild(child: Mesh): void;
    RecheckProp(): Promise<void>;
    checkLarger(): void;
    set wireframe(wireframe: boolean);
    destroy(): void;
    get isValidCell(): boolean;
}
