import { Vector3, Object3D, Vector2 } from 'three';
import { Row } from './Row';
import { GridBaseElement } from './GridBaseElement';
import { Table } from './Table';
import { Cell } from './Cell';
/**
 * example:
 *  var grid = new Grid(this.appManager.scene, null, 4,3,2, new Vector3(0, 0, 5), new Vector3(1, 1, 1));
 *  await grid.init();
 *  grid.wireframe = true;
 *  grid.enable();
 */
export declare class Grid extends GridBaseElement {
    colSize: number;
    rowSize: number;
    depthSize: number;
    tables: Table[];
    padding: number;
    margin: Vector2;
    constructor(parent: GridBaseElement | Object3D, colSize: number, rowSize: number, depthSize: number, initialPosition: Vector3, cellSize: Vector3, padding?: number, margin?: Vector2);
    init(): void;
    getCells(): Cell[];
    getRows(): Row[];
    getTables(): Table[];
    enable(): Promise<void>;
    disable(): void;
    set wireframe(wireframe: boolean);
    RecheckProp(): void;
}
