import { MeshBasicMaterial, BoxGeometry, Mesh, Object3D, Vector3, BoxHelper, Euler } from 'three';
import { EventDispatcher, IEvent } from 'strongly-typed-events';
export interface IGridBaseElement {
    _OnPropertieChanged: EventDispatcher<GridBaseElement, string>;
    parent: GridBaseElement | Object3D;
    initialPosition?: Vector3;
    obj: Mesh;
    geometry: BoxGeometry;
    material: MeshBasicMaterial;
    gridChild: GridBaseElement;
    boxHelper: BoxHelper;
    cellSize: Vector3;
    _wireframe: boolean;
    init(): any;
    enable(): any;
    disable(): any;
    checkProp(): any;
    setPosition(vector: Vector3, time: number): any;
    setRotation(vector: Euler, time: number): any;
    setScale(vector: Vector3, time: number): any;
    destroy(): any;
}
export declare class GridBaseElement implements IGridBaseElement {
    _OnPropertieChanged: EventDispatcher<GridBaseElement, string>;
    parent: GridBaseElement | Object3D;
    initialPosition?: Vector3;
    obj: Mesh;
    geometry: BoxGeometry;
    material: MeshBasicMaterial;
    gridChild: GridBaseElement;
    cellSize: Vector3;
    enabled: boolean;
    boxHelper: BoxHelper;
    _wireframe: boolean;
    constructor(parent: GridBaseElement | Object3D, initialPosition: Vector3, cellSize: Vector3);
    init(): void;
    enable(): void;
    disable(): void;
    checkProp(): void;
    get wireframe(): boolean;
    set wireframe(wireframe: boolean);
    get OnPropertieChanged(): IEvent<GridBaseElement, string>;
    setPosition(vector: Vector3, time?: number): Promise<any>;
    setRotation(vector: Euler, time?: number): Promise<any>;
    setScale(vector: Vector3, time?: number): Promise<any>;
    destroy(): void;
}
