import { Vector3, Object3D, Vector2 } from 'three';
import { Cell } from './Cell';
import { GridBaseElement } from './GridBaseElement';
/**
 * example:
 *  var row = new Row(this.appManager.scene, null, 5, new Vector3(3, 0, 7), new Vector3(1, 1, 1));
 *  await row.init();
 *  row.wireframe = true;
 *  row.enable();
 */
export declare class Row extends GridBaseElement {
    colSize: number;
    cells: Cell[];
    padding: number;
    margin: Vector2;
    constructor(parent: GridBaseElement | Object3D, colSize: number, initialPosition: Vector3, cellSize: Vector3, padding?: number, margin?: Vector2);
    init(): void;
    getCells(): Cell[];
    enable(): Promise<void>;
    disable(): void;
    set wireframe(wireframe: boolean);
    RecheckProp(): void;
}
