import { Vector3, Object3D, Vector2 } from 'three';
import { Row } from './Row';
import { GridBaseElement } from './GridBaseElement';
import { Cell } from './Cell';
/**
 * example:
 *  var table = new Table(this.appManager.scene, null, 5,7, new Vector3(-3, 3, 10), new Vector3(1, 1, 1));
 *  await table.init();
 *  table.wireframe = true;
 *  table.enable();
 */
export declare class Table extends GridBaseElement {
    colSize: number;
    rowSize: number;
    rows: Row[];
    padding: number;
    margin: Vector2;
    constructor(parent: GridBaseElement | Object3D, colSize: number, rowSize: number, initialPosition: Vector3, cellSize: Vector3, padding?: number, margin?: Vector2);
    init(): void;
    getCells(): Cell[];
    getRows(): Row[];
    enable(): Promise<void>;
    disable(): void;
    set wireframe(wireframe: boolean);
    RecheckProp(): void;
}
