import { Mesh, MeshStandardMaterial } from 'three';
import { ByondBaseElement } from '../../Core/ByondBaseElement';
import { MeshScreenMetadata } from '../../Factories/ObjectModelFactory/Metadata';
import { ScreenImage } from '../Screens/ScreenImage';
import { ScreenVideo } from '../Screens/ScreenVideo';
import { ScreenNavigation } from '../Screens/ScreenNavigation';
export declare class MeshImageScreen extends ScreenImage {
    constructor(obj: Mesh, metadata: MeshScreenMetadata, parent: ByondBaseElement, element_id?: string);
    init(): Promise<void>;
    touch(): void;
    activateElement(self: MeshImageScreen, preventScreenAnimation?: boolean): Promise<void>;
    loadImage(url: string, disableResize?: boolean, stopCheck?: () => boolean): Promise<import("three").Texture>;
}
export declare class MeshVideoScreen extends ScreenVideo {
    material: MeshStandardMaterial;
    constructor(obj: Mesh, metadata: MeshScreenMetadata, parent: ByondBaseElement, element_id?: string);
    init(): Promise<void>;
    activateElement(self: MeshVideoScreen, preventScreenAnimation?: boolean): Promise<void>;
    protected initVideo(disableResize?: boolean): void;
    protected OnVideoEnded(disableResize?: boolean): Promise<void>;
    applyAnimateScreenToFov(): Promise<void>;
}
export declare class MeshNavigationScreen extends ScreenNavigation {
    material: MeshStandardMaterial;
    constructor(obj: Mesh, metadata: MeshScreenMetadata, parent: ByondBaseElement, element_id?: string);
    init(): Promise<void>;
}
