import { Mesh, Material, Object3D, Vector3, AnimationMixer, Geometry, BufferGeometry } from 'three';
import { MeshImageScreen, MeshVideoScreen, MeshNavigationScreen } from './MeshGenericScreen';
import { ObjModelMetadata, MeshScreenMetadata } from '../../Factories/ObjectModelFactory/Metadata';
import { ByondInteractiveElement } from '../../Core/ByondInteractiveElement';
import { ByondBaseElement } from '../../Core/ByondBaseElement';
import { LodSupported, LodManager, LodOption } from '../../Core/LODManager';
export declare class ObJModel extends ByondInteractiveElement implements LodSupported {
    modelBaseDir: string;
    childElements: (MeshImageScreen | MeshVideoScreen | MeshNavigationScreen)[];
    meshes: Mesh<Geometry | BufferGeometry, Material | Material[]>[];
    opacityMap: Map<Material, number>;
    tranperantMap: Map<Material, boolean>;
    rotationEffects: any[];
    animationMixer: AnimationMixer;
    lodManager: LodManager;
    constructor(metadata: ObjModelMetadata, parent: ByondBaseElement, element_id?: string);
    init(): Promise<void>;
    loadModel(): Promise<void>;
    setCenterPivot(): void;
    registerModel(): void;
    registerMeshes(): void;
    registerMaterials(): void;
    registerEvents(): void;
    private getChildScreen;
    initScreen(meshScreenMetadata: MeshScreenMetadata): Promise<void>;
    setEnabled(enable: boolean): void;
    setAlpha(alpha: number, time?: number): Promise<any>;
    isScreenChildMesh(mesh: Mesh): boolean;
    setVisible(visible: boolean, time?: number): Promise<any>;
    onHover(): void;
    onUnHover(): void;
    startRotationEffect(value: Vector3): void;
    stopRotationEffect(): void;
    getMetadata(): ObjModelMetadata;
    destroy(): void;
    changeLod(lodOption: LodOption): Promise<void>;
    changeMeshByName(name: string, obj: Object3D, geometry: Geometry | BufferGeometry, material: Material | Material[]): void;
}
