import { ScreenImage } from './ScreenImage';
import { ScreenMetadata } from '../../Factories/ScreenFactory/Metadata';
import { ByondBaseElement } from '../../Core/ByondBaseElement';
import { Mesh, Texture } from 'three';
import { Image } from '../../Utils/Image';
export interface BulletOptions {
    bullets: Array<BulletOption>;
    type?: 'auto';
    coverage?: number;
    preserve_orientation?: boolean;
}
export interface BulletOption {
    angle_start: number;
    angle_end: number;
    url: string;
}
export declare class ScreenBulletImage extends ScreenImage {
    bulletOptions: BulletOptions;
    currentNBullet: number;
    lookAtCamera: boolean;
    calc_obj: Mesh;
    bulletImages: Array<{
        image: Image;
        texture: Promise<Texture>;
    }>;
    constructor(bulletOptions: BulletOptions, metadata: ScreenMetadata, parent: ByondBaseElement, element_id?: string);
    activateElement(self: ScreenImage): Promise<void>;
    /** only for angles between -360 to 360 */
    normalizeAngle(angle: number): number;
    init(): Promise<void>;
    setVisible(visible: boolean, time?: number): Promise<any>;
    preloadImages(): void;
    preloadImage(url: string): {
        image: Image;
        texture: Promise<Texture>;
    };
    calc(): void;
    getNbullet(angle: number): number;
    loadBulletNImage(nBullet: number): Promise<void>;
    destroy(): void;
}
