import { Vector2, Vector3, Mesh, MeshStandardMaterial, MeshPhongMaterial } from 'three';
import { Image } from '../../Utils/Image';
import { TextElement } from '../TextElement';
import { ByondInteractiveElement } from '../../Core/ByondInteractiveElement';
import { ByondBaseElement } from '../../Core/ByondBaseElement';
import { ScreenMetadata } from '../../Factories/ScreenFactory/Metadata';
export interface ProxyImageOptions {
    url: string;
    parameters: Array<{
        key: string;
        value: string;
    }>;
}
export interface ProgressiveUrlsOptions {
    preview: Array<string> | Array<ProxyImageOptions>;
    type: string;
}
export declare class ScreenImpl extends ByondInteractiveElement {
    obj: Mesh;
    protected previewImage: Image;
    protected material: MeshStandardMaterial | MeshPhongMaterial;
    protected metadata: ScreenMetadata;
    protected title: TextElement;
    protected geoSize: Vector2;
    private lineSegments;
    protected triggerAnimTime: number;
    protected fovAnimations: any[];
    set Title(t: TextElement);
    get Title(): TextElement;
    stopPreviewProgressiveImageLoading: boolean;
    constructor(metadata: ScreenMetadata, parent: ByondBaseElement, element_id?: string);
    init(): Promise<any>;
    getProxyImageUrl(url: string, proxyImageOptions: ProxyImageOptions): string;
    loadPreviewImage(disableResize?: boolean, preventProgressive?: boolean): Promise<void>;
    stopLoadingImageCheck(): boolean;
    loadImage(url: string, disableResize?: boolean, stopCheck?: () => boolean): Promise<import("three").Texture>;
    loadProgressiveImages(urls: Array<string>, disableResize?: boolean, stopCheck?: () => boolean, index?: number): Promise<import("three").Texture>;
    getPreviewImage(): any;
    getMetadata(): ScreenMetadata;
    onHover(): void;
    onUnHover(): void;
    destroy(): void;
    setVisible(visible: boolean, time?: number): Promise<any>;
    applyAnimateScreenToFov(): Promise<void>;
    stopFovAnimation(): void;
    animateScreenToFov(animTime: number, growPrecentValue?: number, axisOffset?: Vector3): Promise<void>;
}
