import * as Video from '../../Utils/Video';
import { ScreenImpl } from './ScreenImpl';
import { ByondBaseElement } from '../../Core/ByondBaseElement';
import { ScreenVideoMetadata } from '../../Factories/ScreenFactory/Metadata';
export declare class ScreenVideo extends ScreenImpl {
    video: Video.Video;
    autoPlay: boolean;
    loop: boolean;
    private chromakeyMaterial;
    playFullScreen: boolean;
    constructor(metadata: ScreenVideoMetadata, parent: ByondBaseElement, element_id?: string);
    init(): Promise<void>;
    protected initVideo(disableResize?: boolean): void;
    setVisible(visible: boolean, time?: number): Promise<any>;
    setEnabled(enable: boolean): void;
    deactivateElement(): Promise<void>;
    protected OnVideoEnded(disableResize?: boolean): Promise<void>;
    activateElement(self: ScreenVideo, preventScreenAnimation?: boolean): Promise<void>;
    playVideo(preventScreenAnimation: boolean): Promise<void>;
    destroy(): void;
    play(offset?: number): void;
    stop(): void;
    pause(): void;
    resume(): void;
    set CurrentTime(offset: number);
    get CurrentTime(): number;
    get volume(): number;
    set volume(v: number);
    getMetadata(): ScreenVideoMetadata;
}
