import { Metadata } from '../../Core/Metadata';
import { ByondBaseElement } from '../../Core/ByondBaseElement';
import { ZoneManagerImpl } from './ZoneManagerImpl';
import { ARMarkerManager } from '../../Core/ARMarkerManager';
import { CameraBtn } from '../../UIElements/CameraBtn/CameraBtn';
import { AROverlay } from '../../UIElements/AROverlay/AROverlay';
import { Vector2 } from 'three';
export declare class ARMarkerZoneManager extends ZoneManagerImpl {
    elementsList: Array<ByondBaseElement>;
    arManager: ARMarkerManager;
    pinnedMarker: boolean;
    cameraBtn: CameraBtn;
    overlay: AROverlay;
    iteractionShowed: boolean;
    constructor(metadata: Metadata.ZoneMetadata, parent: ByondBaseElement, element_id?: string);
    init(): Promise<void>;
    captureCanvas(): Promise<void>;
    registerEvents(): void;
    registerInteractions(): void;
    onPinch(delta: number): void;
    onSwipe(deltaVector: Vector2): void;
    onMarker(): void;
    offMarker(): void;
    destroy(): void;
}
