import { Metadata } from '../../Core/Metadata';
import { ByondBaseElement } from '../../Core/ByondBaseElement';
import { ZoneManagerImpl } from './ZoneManagerImpl';
import { Subscription } from 'rxjs';
export declare class ARZoneManager extends ZoneManagerImpl {
    elementsList: Array<ByondBaseElement>;
    onDeviceOrientationChangeFunc: any;
    placeSceneFunc: any;
    onPinchSub: Subscription;
    onRotateSub: Subscription;
    onSwipeFunc: (event: MouseEvent | TouchEvent) => void;
    constructor(metadata: Metadata.ZoneMetadata, parent: ByondBaseElement, element_id?: string);
    init(): Promise<void>;
    setSceneAlpha(): Promise<void>;
    resetZone(): void;
    setEnabled(enable: boolean): void;
    addPlaceZoneListeners(): void;
    removePlaceZoneListeners(): void;
    setCameraheight(height: number): void;
    placeScene(e: TouchEvent | MouseEvent): Promise<void>;
    setVisible(visible: boolean, time?: number): Promise<any>;
    setGammaFactor(gammaFactor: any): void;
    initXRModule(): Promise<void>;
    registerInteractions(): void;
    unRegisterInteractions(): void;
    onPinch(delta: number): void;
    onSwipe(e: TouchEvent | MouseEvent): void;
    onRotate(msg: {
        delta: number;
    }): void;
    destroy(): void;
    onDeviceOrientationChange(orientation: any): void;
}
