import { IZoneManagerImpl } from './ZoneManagerImpl.interface';
import { Metadata } from '../../Core/Metadata';
import { ByondBaseElement } from '../../Core/ByondBaseElement';
import { Subscription } from 'rxjs';
import { OrbitBasedCameraControls } from '../../Controls/CameraControls/OrbitBasedCameraControls';
import { IByondBaseElement } from '../../Core/ByondBaseElement.interface';
export declare const CameraAttribute = "$$camera";
export declare class ZoneManagerImpl extends ByondBaseElement implements IZoneManagerImpl {
    elementsList: Array<ByondBaseElement>;
    cameraHeight: number;
    ZoomSub: Subscription;
    PinchSub: Subscription;
    constructor(metadata: Metadata.ZoneMetadata, parent: ByondBaseElement, element_id?: string);
    init(): Promise<void>;
    setCameraheight(height: number): void;
    afterInit(): void;
    createElements(): Promise<ByondBaseElement[]>;
    getElementByMetadata(elementsMetadata: any): Promise<ByondBaseElement[]>;
    getMetadata(): Metadata.ZoneMetadata;
    resetZone(): void;
    onChildDestroyed(child: IByondBaseElement): void;
    destroy(): void;
    handleDependencies(): Promise<void>;
    checkGammaFactor(): void;
    setGammaFactor(gammaFactor: number): void;
    checkDefaultCameraZoom(): void;
    checkDefaultEntryPoint(): Promise<void>;
    getEntryPoints(): Promise<ByondBaseElement[]>;
    handleCameraAttributeAfterInit(): void;
    setZoomSupport(camera_zoom: {
        min: number;
        max: number;
        factor: number;
    }): void;
    unsetZoomSupport(camCtrl: OrbitBasedCameraControls): void;
    onZoom(delta: number, min: number, max: number, factor: number): void;
}
