import './Chat.less';
import { Texture } from 'three';
import { ChatElementMetadata } from './Metadata';
import { CanvasInteractiveElement } from '../../Elements/CanvasElements/CanvasInteractiveElement';
import { ByondBaseElement } from '../../Core/ByondBaseElement';
/**
 * example:
 *
 */
export declare class Chat extends CanvasInteractiveElement {
    messages: Array<ChatMessage>;
    chatFontCanvasStyle: string;
    constructor(metadata: ChatElementMetadata, parent: ByondBaseElement, element_id?: string, isTransparent?: boolean, width?: number, height?: number);
    init(): Promise<void>;
    addNewMessage(elm: Chat, msg: ChatMessage): void;
    getTextureFromCanvas(): Texture;
    writeMessageOnCanvas(msg: ChatMessage, fromLine: number): number;
}
/** types: other, me, host, notification */
export declare class ChatMessage {
    name: string;
    content: string;
    time: string;
    type: string;
}
