import { Vector3, Texture } from 'three';
import { VRKey, KeysRow } from './VRKey';
import { IEventMessage } from '../../Core/EventManager/EventMessageImpl';
import { KeyboardMetadata } from './VRKeyboardMetadata';
import { CanvasInteractiveElement } from '../../Elements/CanvasElements/CanvasInteractiveElement';
import { ByondBaseElement } from '../../Core/ByondBaseElement';
import { KeyData } from './Interfaces/KeyData';
import { VRDKeyboardDesignOption } from './Interfaces/VRDKeyboardDesignOption';
export declare class VRKeyboard extends CanvasInteractiveElement {
    layouts: Map<string, Array<Array<KeyData>>>;
    keys: Array<VRKey>;
    rows: Array<KeysRow>;
    currentType: string;
    currentLayout: Array<Array<KeyData>>;
    vRDKeyboardDesignOption: VRDKeyboardDesignOption;
    keyBoardWidth: number;
    keyBoardheight: number;
    pressedKeys: any[];
    constructor(metadata: KeyboardMetadata, parent: ByondBaseElement, element_id?: string, isTransparent?: boolean);
    init(): Promise<void>;
    initKeyboard(layout?: string): void;
    registerEvents(): void;
    onClick(event: IEventMessage): void;
    changeNumericalLayout(): void;
    changeNumericalAlt(): void;
    changeUpperLowerLayout(): void;
    changeAlphabetNumericLayout(): void;
    keyClickedEffect(key: VRKey): void;
    checkCollides(hitPosition: Vector3): VRKey;
    clear(): void;
    getTextureFromCanvas(): Texture;
    drawKeys(rows: Array<KeysRow>): void;
}
