import { CanvasInteractiveElement } from '../../Elements/CanvasElements/CanvasInteractiveElement';
import { Texture } from 'three';
import { IEventMessage } from '../../Core/EventManager/EventMessageImpl';
import { VRKeyboard } from '../VRKeyboard/VRKeyboard';
import { TextInputMetadata } from './VRTextInputMetadata';
import { ByondBaseElement } from '../../Core/ByondBaseElement';
import { VRTextInputDesignOption } from './VRTextInputOptions';
export declare class VRTextInput extends CanvasInteractiveElement {
    vRTextInputDesignOption: VRTextInputDesignOption;
    value: string;
    placeholder: string;
    private displayAsPassword;
    hasFocus: boolean;
    private blink;
    private cursor;
    private attachedKeyboards;
    constructor(metadata: TextInputMetadata, parent: ByondBaseElement, element_id?: string, widht?: number, height?: number);
    init(): Promise<void>;
    AttacheKeyBoard(vRKeyboard: VRKeyboard): void;
    registerEvents(): void;
    handleKeyClicked(event: IEventMessage): void;
    onInputFocus(event: IEventMessage): void;
    clear(): void;
    startBlink(): void;
    onUnfocusInputText(): void;
    getTextureFromCanvas(): Texture;
}
