import { TextureFilter, CanvasTexture, PixelFormat, Mapping, Wrapping, TextureDataType, Clock } from 'three';
import { GifReader, Frame } from 'omggif';
export declare class GifTexture extends CanvasTexture {
    reader: GifReader;
    context: CanvasRenderingContext2D;
    previousFrameInfo: Frame;
    isPlaying: boolean;
    clock: Clock;
    gifTotalTime: number;
    totalNFrames: number;
    lastDrawFrameNumber: number;
    constructor(mapping?: Mapping, wrapS?: Wrapping, wrapT?: Wrapping, magFilter?: TextureFilter, minFilter?: TextureFilter, format?: PixelFormat, type?: TextureDataType, anisotropy?: number);
    setReader(reader: GifReader): void;
    draw(frameNum: number): void;
    render(): void;
    play(): void;
    stop(): void;
    dispose(): void;
}
