import { Vector3, Euler, Quaternion } from 'three';
import { AppManager } from '../ByondViewer';
export declare class GyroOptions {
    max_x: number;
    min_x: number;
    max_y: number;
    min_y: number;
    max_z: number;
    min_z: number;
    motion: GyroMotionOptions;
}
export declare class GyroMotionOptions {
    x_axis: MotionAxisOptions;
    z_axis: MotionAxisOptions;
}
export declare class MotionAxisOptions {
    angle_threshold: number;
    angle_duration: number;
    distance: number;
    motion_duration: number;
}
export declare class GyroscopeManager {
    initialRotation: Euler;
    initialCenter: Euler;
    rotation: Euler;
    preResetRotation: Euler;
    quaternion: Quaternion;
    zee: Vector3;
    euler: Euler;
    q0: Quaternion;
    q1: Quaternion;
    deviceOrientation: any;
    screenOrientation: any;
    initialScreenOrientation: any;
    zCenter: number;
    xCenter: number;
    yCenter: number;
    options: GyroOptions;
    xMotionQueue: number[];
    zMotionQueue: number[];
    androidFactor: number;
    ScreenOrientationChangeEvent: any;
    DeviceOrientationChangeEvent: any;
    firstInit: boolean;
    gyroReseted: boolean;
    appManager: AppManager;
    constructor(appManager: AppManager, options: GyroOptions, initialCenter?: Euler);
    init(): void;
    initMembers(initialCenter?: Euler, options?: GyroOptions): void;
    setGyroOptions(options: GyroOptions): void;
    onDeviceOrientationChangeEvent(event: any): void;
    onScreenOrientationChangeEvent(): void;
    setQuaternion(z: number, x: number, y: number, orient: number): void;
    recenterCoordinates(): void;
    calculateNewCenters(x: any, maxX: any, minX: any, y: any, maxY: any, minY: any, z: any, maxZ: any, minZ: any): void;
    handleMotion(): void;
    fireMotionEvent(axis: string, direction: number): void;
    update(): void;
    getGyroCoordinates(): Euler;
    isAndroid(): boolean;
}
