import { Texture, TextureFilter, TextureEncoding } from 'three';
import { AppManager } from '../ByondViewer';
export declare let SVGCanvasHeight: number;
export declare let SVGCanvasWidth: number;
export declare class ImageOptions {
    url: string;
    minFilter?: TextureFilter;
    magFilter?: TextureFilter;
    anisotropy?: number;
    generateMipmaps?: boolean;
    encoding?: TextureEncoding;
    optimizerWidth?: number;
    svgSize?: {
        width: number;
        height: number;
    };
}
export declare class Image {
    Texture: Texture;
    imageOptions: ImageOptions;
    private canvas;
    private isDisposed;
    appManager: AppManager;
    constructor(appManager: AppManager, imageOptions: ImageOptions);
    Load(): Promise<Texture>;
    private LoadImage;
    private _LoadImage;
    private loadGif;
    private loadSVG;
    private setTextureProp;
    Dispose(): void;
}
