import { JSZipObject } from 'jszip';
import 'fileSystemPolyfill';
declare global {
    interface Window {
        requestFileSystem: Function;
        webkitRequestFileSystem: Function;
        TEMPORARY: string;
    }
}
export declare namespace JsUtils {
    const FileSystemPrefix: string;
    function injectCssFile(href: string, integrity?: string): HTMLLinkElement;
    function injectJsFile(src: string, type?: 'text/javascript' | 'application/javascript'): Promise<unknown>;
    function injectFontFile(src: string, name: string): Promise<void>;
    function GetQueryFromUrl(name: string, url?: string): string;
    function GetQuerysFromUrl(): Map<string, string>;
    function SaveFileToFileSystem(path: string, data: Blob): Promise<string>;
    function SaveDirectoryToFileSystem(path: string): Promise<string>;
    function LoadZipData(zipData: any): Promise<any>;
    function ZipDataToBlob(zipObj: JSZipObject): Promise<Blob>;
    function DownloadFile(url: string, options?: any): Promise<any>;
    function SaveAsDataUrl(dataurl: string, fileName: string): void;
    function loadImage(src: string | Blob): Promise<HTMLImageElement>;
    function canvasToImageData(canvas: HTMLCanvasElement): Promise<string>;
    function canvasToImageAsync(canvas: HTMLCanvasElement): Promise<HTMLImageElement>;
    function resizeImage(image: HTMLImageElement, width: number, height: number): Promise<HTMLImageElement>;
    function setHtmlOpacity(html: HTMLElement, alpha: number, time?: number, onUpdate?: any): Promise<any>;
    function strMapToObj(strMap: Map<string, string>): any;
    function isIframe(): boolean;
    function OpenVideoInTab(src: string): Promise<void>;
}
