import { Object3D, Group } from 'three';
import { GLTF } from 'three/examples/jsm/loaders/GLTFLoader';
import { MTLLoader } from 'three/examples/jsm/loaders/MTLLoader';
import { AppManager } from '../ByondViewer';
export declare namespace ModelsUtils {
    function LoadModelFromUrl(appManager: AppManager, url: string, modelBaseDir: string): Promise<{
        obj: Object3D;
        animationMixer: any;
    }>;
    function loadZipObj(appManager: AppManager, modelBaseDir: string, url: string): Promise<Group>;
    function LoadObjectJsonModel(path: string): Promise<Object3D>;
    function LoadColladaModel(path: string): Promise<any>;
    function LoadFBXModel(appManager: AppManager, url: string): Promise<Group>;
    function LoadGltfModel(appManager: AppManager, url: string): Promise<GLTF>;
    function LoadObjMtl(objPath: string, mtlPath: any, texturePath?: string): Promise<Group>;
    function LoadObJ(path: string, materialCreator?: MTLLoader.MaterialCreator): Promise<Group>;
    function LoadMtl(path: string, texturePath?: string): Promise<MTLLoader.MaterialCreator>;
}
