export declare const vertexShader = "\nattribute vec3 position;\nattribute vec2 uv;\nuniform mat4 projectionMatrix;\nuniform mat4 modelViewMatrix;\nvarying vec2 vUv;\nvoid main()  {\n\tvUv = vec2( 1.- uv.x, uv.y );\n\tgl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );\n}\n";
export declare const fragmentShader = "\nprecision mediump float;\nuniform samplerCube map;\nvarying vec2 vUv;\n#define M_PI 3.1415926535897932384626433832795\nvoid main()  {\n\tvec2 uv = vUv;\n\tfloat longitude = uv.x * 2. * M_PI - M_PI + M_PI / 2.;\n\tfloat latitude = uv.y * M_PI;\n\tvec3 dir = vec3(\n\t\t- sin( longitude ) * sin( latitude ),\n\t\tcos( latitude ),\n\t\t- cos( longitude ) * sin( latitude )\n\t);\n\tnormalize( dir );\n\tgl_FragColor = textureCube( map, dir );\n}\n";
