import { VideoTexture, Texture } from 'three';
import { IEvent } from 'strongly-typed-events';
import { VideoStatus, VideoOptions } from '.';
export declare class Video {
    State: VideoStatus;
    Texture: Texture;
    videoOptions: VideoOptions;
    private Video;
    private _OnStateChanged;
    private _OnTimeUpdate;
    private muteVol;
    constructor(videoOptions: VideoOptions);
    Load(event?: any): Promise<VideoTexture>;
    getWidth(): number;
    getHeight(): number;
    private LoadVideo;
    get OnTimeUpdate(): IEvent<Video, number>;
    get OnStateChanged(): IEvent<Video, VideoStatus>;
    private setState;
    CurrentTime(): number;
    set volume(v: number);
    get volume(): number;
    get Duration(): number;
    Seek(seek: number): void;
    get IsPlaying(): boolean;
    Play(): void;
    Pause(): void;
    Stop(): void;
    get IsMuted(): boolean;
    Mute(): void;
    Unmute(): void;
    Dispose(): void;
}
